//***********************************************************************
//
//  Draw.cpp
//
//***********************************************************************

#include <afxwin.h>
#include <afxcoll.h>
#include <afxext.h>
#include "Resource.h"
#include "Circle.h"
#include "Draw.h"
#include "MainFrame.h"
#include "DrawDoc.h"
#include "DrawView.h"

CDrawApp myApp;

BEGIN_MESSAGE_MAP (CDrawApp, CWinApp)
    ON_COMMAND (ID_FILE_NEW, CWinApp::OnFileNew)
    ON_COMMAND (ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP ()

BOOL CDrawApp::InitInstance ()
{
    SetRegistryKey ("Power Programming Samples");
    LoadStdProfileSettings ();

    CSingleDocTemplate* pDocTemplate;
    pDocTemplate = new CSingleDocTemplate (
        IDR_MAINFRAME,
        RUNTIME_CLASS (CDrawDoc),
        RUNTIME_CLASS (CMainFrame),
        RUNTIME_CLASS (CDrawView)
    );

    AddDocTemplate (pDocTemplate);
    RegisterShellFileTypes (TRUE);

    CCommandLineInfo cmdInfo;
    ParseCommandLine (cmdInfo);

    if (!ProcessShellCommand (cmdInfo))
        return FALSE;

    m_pMainWnd->DragAcceptFiles ();
    return TRUE;
}
